//+----------------------------------------------------------------------------+
//|                                                          e-OpenByTime.mq4  |
//|                                                                            |
//|        : ,  sibtrade@hotbox.ru                                 |
//|  :   . aka KimIV, http://www.kimiv.ru                   |
//|                                                                            |
//|  2007.04.27      .                            |
//+----------------------------------------------------------------------------+

#property copyright " & KimIV"
#property link  "http://www.kimiv.ru"

//-------    ------------------------------------------
extern string _P_Trade = "----------  ";
extern string TimeTrade  = "19:51";    //   
extern bool   Sell       = False;      // True-Sell, False-Buy
extern double Lots       = 0.1;        //  
extern int    StopLoss   = 30;         //    
extern int    TakeProfit = 60;         //    

extern string _P_Expert = "----------  ";
extern int    MagicNumber     = 0;
extern int    NumberAccount   = 0;               //   
extern bool   UseSound        = True;            //   
extern string NameFileSound   = "expert.wav";    //   
extern bool   ShowComment     = True;            //  
extern int    Slippage        = 3;               //  
extern int    NumberOfTry     = 5;               //   
extern int    PauseAfterError = 75;              //     
                                                
//-------    --------------------------------------
bool   gbDisabled   = False;      //   
color  clOpenBuy    = LightBlue;  //    
color  clOpenSell   = LightCoral; //    

//-------    ------------------------------------------
#include <stdlib.mqh>        //   4


//+----------------------------------------------------------------------------+
//|                                                                            |
//|  ˨                                                   |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|                                                        |
//+----------------------------------------------------------------------------+
void init() {
  gbDisabled = False;
  if (!IsTradeAllowed()) {
    Message("    \n"+
            "  ");
    gbDisabled=True; return;
  }
  if (!IsLibrariesAllowed()) {
    Message("    \n"+
            "    ");
    gbDisabled=True; return;
  }
  if (!IsTesting()) {
    if (IsExpertEnabled()) Message("    ");
    else Message("  \"  \"");
  }
}

//+----------------------------------------------------------------------------+
//|                                                      |
//+----------------------------------------------------------------------------+
void deinit() { if (!IsTesting()) Comment(""); }

//+----------------------------------------------------------------------------+
//|  expert start function                                                     |
//+----------------------------------------------------------------------------+
void start() {
  if (gbDisabled) {
    Message("   !"); return;
  }
  if(DayOfWeek()==0 || DayOfWeek()==6) return;
  if (AccountFreeMargin()<1000*Lots) {
    Print("  . Free Margin = ", AccountFreeMargin());
    return;  
  }
  if (!IsTesting()) {
    if (NumberAccount>0 && NumberAccount!=AccountNumber()) {
      Comment("  : "+AccountNumber()+" !");
      return;
    } else Comment("");
    if (ShowComment) {
      string st="CurTime="+TimeToStr(TimeCurrent(), TIME_MINUTES)
               +"  TimeTrade="+TimeTrade
               +"  ="+GetNameOP(Sell)
               +"  Lots="+DoubleToStr(Lots, 1)
               +"  StopLoss="+DoubleToStr(StopLoss, 0)+" ."
               +"  TakeProfit="+DoubleToStr(TakeProfit, 0)+" ."
               ;
      Comment(st);
    } else Comment("");
  }

  if (TimeCurrent()>StrToTime(TimeToStr(TimeCurrent(), TIME_DATE)+" "+TimeTrade)) {
    if (!ExistPositions("", Sell, MagicNumber)) {
      double sl, tp;
      if (Sell) {
        if (StopLoss>0) sl=Bid+StopLoss*Point; else sl=0;
        if (TakeProfit>0) tp=Bid-TakeProfit*Point; else tp=0;
      } else {
        if (StopLoss>0) sl=Ask-StopLoss*Point; else sl=0;
        if (TakeProfit>0) tp=Ask+TakeProfit*Point; else tp=0;
      }
      OpenPosition(Sell, sl, tp, MagicNumber);
    }
  }
}


//+----------------------------------------------------------------------------+
//|                                                                            |
//|                                                     |
//|                                                                            |
//+----------------------------------------------------------------------------+
//|                                          |
//|  :                                                                |
//|    sym -    ("" -  )                   |
//|    op  -                   (-1 -  )                    |
//|    mn  - MagicNumber               (-1 -  )                      |
//+----------------------------------------------------------------------------+
bool ExistPositions(string sym="", int op=-1, int mn=-1) {
  int i, k=OrdersTotal();

  if (sym=="") sym=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sym) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) return(True);
          }
        }
      }
    }
  }
  return(False);
}

//+----------------------------------------------------------------------------+
//|                                      |
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
	switch (op) {
		case OP_BUY      : return("Buy");
		case OP_SELL     : return("Sell");
		case OP_BUYLIMIT : return("Buy Limit");
		case OP_SELLLIMIT: return("Sell Limit");
		case OP_BUYSTOP  : return("Buy Stop");
		case OP_SELLSTOP : return("Sell Stop");
		default          : return("Unknown Operation");
	}
}

//+----------------------------------------------------------------------------+
//|                                            |
//+----------------------------------------------------------------------------+
string GetNameTF(int TimeFrame) {
	switch (TimeFrame) {
		case PERIOD_M1:  return("M1");
		case PERIOD_M5:  return("M5");
		case PERIOD_M15: return("M15");
		case PERIOD_M30: return("M30");
		case PERIOD_H1:  return("H1");
		case PERIOD_H4:  return("H4");
		case PERIOD_D1:  return("Daily");
		case PERIOD_W1:  return("Weekly");
		case PERIOD_MN1: return("Monthly");
		default:		     return("UnknownPeriod");
	}
}

//+----------------------------------------------------------------------------+
//|                                                        |
//+----------------------------------------------------------------------------+
double GetSizeLot() { return(Lots); }

//+----------------------------------------------------------------------------+
//|                                              |
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}

//+----------------------------------------------------------------------------+
//|                                                             |
//|  :                                                                |
//|    op -                                                            |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - MagicNumber                                                        |
//+----------------------------------------------------------------------------+
void OpenPosition(int op, double sl=0, double tp=0, int mn=0) {
  color  clOpen;
  double ll, pp;
  int    err, it, ticket;
  string lsComm=WindowExpertName()+" "+GetNameTF(Period());

  if (op==OP_BUY) clOpen=clOpenBuy; else clOpen=clOpenSell;
  ll=GetSizeLot();
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    if (op==OP_BUY) pp=Ask; else pp=Bid;
    pp=NormalizeDouble(pp, Digits);
    ticket=OrderSend(Symbol(),op,ll,pp,Slippage,sl,tp,lsComm,mn,0,clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      if (err==128 || err==142 || err==143 || err==144) {
        Sleep(1000*PauseAfterError);
        if (ExistPositions(Symbol(), op, mn)) {
          if (UseSound) PlaySound(NameFileSound); break;
        }
        Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
        continue;
      }
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*PauseAfterError);
      Print("Error(",err,") opening position: ",ErrorDescription(err),", try ",it);
      Print("Ask=",Ask,"  Bid=",Bid,"  ll=",ll,"  op=",GetNameOP(op),
            "  pp=",pp,"  sl=",sl,"  tp=",tp,"  mn=",mn);
      if (err==2 || err==64 || err==65 || err==4110 || err==4111) break;
      Sleep(1000*PauseAfterError);
    }
  }
}
//+----------------------------------------------------------------------------+

